#
# File: osxdmg.mk
# Creator: George Ferguson
# Created: Thu Jul  1 15:26:57 2010
# Time-stamp: <Tue Jul  6 14:23:30 EDT 2010 ferguson>
#
# For now, this file assumes to come after osxapp.mk, but you could
# Set the necessary variables yourself here (or elsewhere before including
# this).
#
# Pointers:
# - Old but useful info about hdiutil at end:
#   http://www.macosxhints.com/article.php?story=20020311215452999
# - On beautifying the folder being imaged:
#   http://digital-sushi.org/entry/how-to-create-a-disk-image-installer-for-apple-mac-os-x/
#   http://jwz.livejournal.com/608927.html
#
# The .DS_Store file used for the image (saved as dot-DS_Store) was
# created by making a disk image, adding the application and the symlink
# to /Applications, getting all view options and icon positions just so,
# then unmounting the image, remounting it, and copying the .DS_Store file.
# The jwz article explains why this is necessary (the rest of the article
# seems unnecessary to me--simple hdiutil command seems to work fine).
#
# Copyright 2010 George Ferguson, ferguson@cs.rochester.edu.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

DMG = "$(Name) $(Version).dmg"

TMPDIR = dmg.dir

dmg:
	-rm -rf $(TMPDIR) $(DMG)
	mkdir $(TMPDIR)
	cp -p dot-DS_Store $(TMPDIR)/.DS_Store
	cp -pr $(APPDIR) $(TMPDIR)
	ln -s /Applications $(TMPDIR)
	hdiutil create -fs HFS+ \
		-srcfolder $(TMPDIR) \
		-volname "$(Name)" \
		$(DMG)

clean::
	-rm -rf $(TMPDIR) $(DMG)
