#
# File: package.mk
# Creator: George Ferguson
# Created: Wed Jun  2 11:17:50 2010
# Time-stamp: <Mon Jun  7 14:00:30 EDT 2010 ferguson>
#
# Makefile targets for building a single package in its own directory.
#
# Copyright 2010 George Ferguson, ferguson@cs.rochester.edu.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Assumes the following are set:
#  PACKAGE  Used to set -sourcepath option for javac
#  SRCS     Used to decide which files to compile
#  CLASSES  Used to clean up
#  MAIN     Used by run target
#  JFLAGS   Options for javac (optional)
#

empty =
space = $(empty) $(empty)

SOURCEPATH = $(subst $(space),$(empty),$(patsubst %,../,$(subst .,$(space),$(PACKAGE))))

ifeq ($(CONFIG_MK),)
include $(SOURCEPATH)/config.mk
endif

.SUFFIXES: .java .class
.java.class:
	$(JAVAC) -sourcepath $(SOURCEPATH) $(JFLAGS) $<

all:: $(SRCS:.java=.class)

clean::
	rm -f $(subst $$,\$$,$(CLASSES))

run::
	$(JAVA) -classpath $(SOURCEPATH) $(JFLAGS) $(PACKAGE).$(MAIN) $(ARGV)

# File is loaded
PACKAGE_MK = 1
